# Contributing

We welcome contributions and suggestions to help us improve this project. If you are unfamiliar with Github, here is their official guide to start [contributing to open source projects](https://guides.github.com/activities/contributing-to-open-source/).

## Workflow

1.  [Fork this repository](https://help.github.com/articles/fork-a-repo)
2.  Create a branch `git checkout -b my-branch`
3.  Stage and commit your changes `git commit -am 'description of my changes’`
4.  Push the changes to your fork `git push origin my-branch`
5.  [Submit a pull request to the parent repo](https://help.github.com/articles/creating-a-pull-request). Please read our [guide to submitting pull requests](https://github.com/inn/docs/blob/master/how-to-work-with-us/pull-requests.md) to see what we expect in a good pull request message.
6.  Pull request should be assigned to:
    - [@ejfox](http://github.com/ejfox) (primary)
    - [@geraldarthur](http://github.com/geraldarthur)
    - [@enjalot](http://github.com/enjalot)

Additionally, you can [create issues](https://github.com/dataproofer/Dataproofer/issues) on this repo to suggest changes or improvements. If you believe there’s a bug, we encourage you to use [best practices](http://polite.technology/reportabug.html), and please tell us the following:

* Describe your computer and the file (e.g. What’s your operating system? How big is your dataset?)
* Describe what you were doing (e.g. Running tests? Which test are you running?)
* Describe what you expected to happen (e.g. Did you expect a particular test to fail?)
* Describe what actually happened (e.g. Did the test in question pass or cause Dataproofer to break?)

And of course you can always email us: [dataproofer@dataproofer.org](mailto:dataproofer@dataproofer.org).

## Code Standards

- Follow our code styleguide (coming soon) and use our (linter configuration file)[https://github.com/dataproofer/Dataproofer/.eslintrc] with your preferred text editor
- Follow our [Code of Conduct](https://github.com/dataproofer/Dataproofer/CODE_OF_CONDUCT.md).
- Use [markdown syntax](http://daringfireball.net/projects/markdown/syntax) for all text documents.
